#include <Adafruit_NeoPixel.h>
#include <RH_ASK.h>
#include <SPI.h> // Not actualy used but needed to compile
#ifdef __AVR__
  #include <avr/power.h>
#endif

#define PIN 6
Adafruit_NeoPixel strip = Adafruit_NeoPixel(71, PIN, NEO_GRB + NEO_KHZ800);

RH_ASK driver;


void setup()
{
    Serial.begin(9600);  // Debugging only
    if (!driver.init())
         Serial.println("init failed");
    strip.begin();
    strip.show(); // Initialize all pixels to 'off'
    strip.setBrightness(64);
}

void loop()
{
    uint8_t buf[5];
    uint8_t buflen = sizeof(buf);

    if (driver.recv(buf, &buflen)) // Non-blocking
    {
      // Message with a good checksum received, dump it.


      //convert message back from char array to double
      char *cTemp = (char*)buf;
      String sTemp(cTemp);
      double dTemp = sTemp.toFloat();

      // For Testing:
      // Serial.print("temperature:  ");
      // Serial.println(dTemp);

      uint16_t i, j;
      float rper, gper, bper, valueset, ratio;
    
      valueset = dTemp;
      
      if (valueset <= 0) //white
      {
        rper = 1;
        gper = 1;
        bper = 1;
      }
      else if (valueset <= 10) //violet
      {
        ratio = valueset/10;
        rper = 1;
        gper = (1-ratio)*1;
        bper = 1;
      }
      else if (valueset <= 30) //blue
      {
        ratio = (valueset-10)/(30-10);
        rper = (1-ratio)*1;
        gper = 0;
        bper = 1;
      }
      else if (valueset <= 40)
      {
        ratio = (valueset-30)/(40-30); //green
        rper = 0;
        gper = ratio*1;
        bper = (1-ratio)*1;
      }
      else if (valueset <= 60) //yellow
      {
        ratio = (valueset-40)/(60-40);
        rper = ratio*.5;
        gper = 1 - (ratio*.5);
        bper = 0;
      }
      else if (valueset <= 70) //orange
      {
        ratio = (valueset-60)/(70-60);
        rper = .5 + (ratio*.5);
        gper = .5;
        bper = 0;
      }
      else if (valueset <= 80)//orange
      {
        rper = 1;
        gper = .5;
        bper = 0;
      }
      else if (valueset <= 90)//red
      {
        ratio = (valueset-80)/(90-80);
        rper = 1;
        gper = .5 - (ratio*.5);
        bper = 0;
      }
      else
      {
        rper = 1;
        gper = 0;
        bper = 0;
      }
    
    
      // set each pixel to color    
      for(i=0; i< strip.numPixels(); i++) 
      {
        strip.setPixelColor(i, strip.Color(round(255*rper), round(255*gper), round(255*bper)));
        
      }
        Serial.println(valueset);        
        strip.show();
        delay(5);
    }
}
